;BCC#50;
;
;Einarmiger Bandit! Wu-hu!
;
;BCC#50;

Graphics3D 800,600,32,2
SetBuffer BackBuffer()

AppTitle "Fredkasino"

SeedRnd MilliSecs()


;SZENE;
Global kampiv=CreatePivot()
	PositionEntity kampiv,0,2.25,0

Global kam=CreateCamera(kampiv),kamgrad#
	PositionEntity kam,0,0,-2.75;-2.75
	RotateEntity kam,15,0,0
	CreateListener(kam)

Global licht=CreateLight()
	RotateEntity licht,45,0,0
	LightColor licht,128,128,112	;224,224,192
	
Global bandit=LoadMesh("banditsphere.b3d");sphere.b3d")
	EntityFX bandit,1
		EntityTexture bandit,LoadTexture("spheremap.png",1+64)
	
	Global banditglanz=LoadMesh("banditsphereglanz.b3d",bandit)
		EntityFX banditglanz,1
		EntityBlend banditglanz,3
			EntityTexture banditglanz,LoadTexture("spheremapglanz.png",1+64)
			EntityColor banditglanz,64,32,16
	
	Global banditstoff=LoadMesh("banditstoff.b3d"),banditstoffsurf=GetSurface(banditstoff,1)
	;	EntityColor banditstoff,64,0,0
		EntityFX banditstoff,2
	
	Global bandithilfe=LoadMesh("bandithilfe.b3d",bandit)
		EntityFX bandithilfe,1
	
	Global banditarm=LoadAnimMesh("banditarm.b3d"),banditarmsurf=GetSurface(banditarm,2)
		;EntityTexture banditarm,LoadTexture("spheremap.png",1+64)
		;EntityFX banditarm,1

Global banditgewinn=LoadSound("gewinn.wav"),banditwette=LoadSound("start.wav")

Global leucht=LoadMesh("leucht.b3d",bandit)
	EntityFX leucht,1
	EntityBlend leucht,3

Global leuchtlayer=LoadTexture("leuchtlayer.png"),leuchtud
	ScaleTexture leuchtlayer,4,8
	EntityTexture leucht,leuchtlayer,0,1


;SZENE;

;"WERBUNG"
	
	;Hintergrund
	
	Global werbungHG=CreateMesh(bandit),werbungHGvO[1],werbungHGvU[1],werbungGrad#=Rand(0,7)*45
			EntityFX werbungHG,1+2
	Global HGsurf=CreateSurface(werbungHG)
		
		werbungHGvO[0]=AddVertex(HGsurf,-0.8,0.8,0	,-0.5,-0.25)
		werbungHGvO[1]=AddVertex(HGsurf,0.8,0.8,0	,0.5,-0.25)
		werbungHGvU[0]=AddVertex(HGsurf,0.8,0,0		,0.5,0.25)
		werbungHGvU[1]=AddVertex(HGsurf,-0.8,0,0	,-0.5,0.25)
		
		AddTriangle(HGsurf,werbungHGvO[0],werbungHGvO[1],werbungHGvU[0])
		AddTriangle(HGsurf,werbungHGvO[0],werbungHGvU[0],werbungHGvU[1])
		
		PositionEntity werbungHG,0,0.1,-1
		
		Global HGstrahlen0=LoadTexture("strahlen.png")
			TextureBlend HGstrahlen0,3
			PositionTexture HGstrahlen0,0.5,0.5
			ScaleTexture HGstrahlen0,1.5,1.5
		
		EntityTexture werbungHG,HGstrahlen0,0,0
		
		
		Global HGstrahlen0Grad#
	
	;Fredkasino!
	
	Global fredkasinotxt=CreateMesh(werbungHG),fredkasinograd#,fredkasinotex=LoadTexture("fredkasinotxt.png",1+2)
		EntityFX fredkasinotxt,1+2
		
		Global fredkasinosurf=CreateSurface(fredkasinotxt)
			
			v0=AddVertex(fredkasinosurf,-0.6, 0.6,0,	-0.5,-0.5);0.25	,0.25)
			v1=AddVertex(fredkasinosurf, 0.6, 0.6,0,	 0.5,-0.5);0.75	,0.25)
			v2=AddVertex(fredkasinosurf, 0.6,-0.6,0,	 0.5, 0.5);0.75	,0.75)
			v3=AddVertex(fredkasinosurf,-0.6,-0.6,0,-0.5, 0.5);0.25	,0.75)
			
			AddTriangle(fredkasinosurf,v0,v1,v2)
			AddTriangle(fredkasinosurf,v0,v2,v3)
		
		PositionEntity fredkasinotxt,0,0.5,-0.1
		EntityTexture fredkasinotxt,fredkasinotex
		PositionTexture fredkasinotex,0.5,0.5
	
	
	Global fredkopf=CreateMesh(werbungHG),fredkopfgrad
		EntityFX fredkopf,1+2
		
		Global fredkopfsurf=CreateSurface(fredkopf)
			
			v0=AddVertex(fredkopfsurf,-0.6, 0.6,0,	0,0)
			v1=AddVertex(fredkopfsurf, 0.6, 0.6,0,	1,0)
			v2=AddVertex(fredkopfsurf, 0.6,-0.6,0,	1,1)
			v3=AddVertex(fredkopfsurf,-0.6,-0.6,0,	0,1)
			
			AddTriangle(fredkopfsurf,v0,v1,v2)
			AddTriangle(fredkopfsurf,v0,v2,v3)
	
		
	PositionEntity fredkopf,0,0.5,-0.1
		EntityTexture fredkopf,LoadTexture("fredkopf.png",1+2)

	;Fredkasino!
		
Function WerbungUpdHG();sonst...weil...ach, vergesst es! :O
			
			kamgrad=(kamgrad+0.1)Mod 360
			
			RotateEntity kampiv,Sin(kamgrad)*10,Sin(kamgrad+180)*5,0
			
			;Stofffarbe?
			
			For i=0 To CountVertices(banditarmsurf)-1
				s#=1;0.50-Int((VertexY(banditstoffsurf,i)/3))*0.5
				v#=1;(VertexY(banditstoffsurf,i)/3.2)*0.75+0.25;(VertexY(banditstoffsurf,i)/4.0)*0.5+0.5
				VertexColor banditarmsurf,i,HSVr(werbungGrad,s,v),HSVg(werbungGrad,s,v),HSVb(werbungGrad,s,v)
			Next
			
			For i=0 To CountVertices(banditstoffsurf)-1
				s#=1;0.50-Int((VertexY(banditstoffsurf,i)/3))*0.5
				v#=(VertexY(banditstoffsurf,i)/3.2)*0.75+0.25;(VertexY(banditstoffsurf,i)/4.0)*0.5+0.5
				VertexColor banditstoffsurf,i,HSVr(werbungGrad,s,v),HSVg(werbungGrad,s,v),HSVb(werbungGrad,s,v)
			Next
			
			;Stofffarbe?
			
			;PointEntity kampiv,bandit
			;TurnEntity kam,15,0,0
			
			
			
			werbungGrad=(werbungGrad+0.1)Mod 360
			
			
			fredkasinoGrad=(fredkasinoGrad-0.5)Mod 360
			
			tr#=Cos(fredkasinograd)*0.5+.1
			
			RotateTexture fredkasinotex,fredkasinograd
			
			fredkopfGrad=(fredkopfGrad+1)Mod 360
			
			
			For i=0 To CountVertices(fredkasinosurf)-1
				s#=0.50-Int((VertexY(fredkasinosurf,i)/0.7))*0.5
				v#=1;0.75;+Int((VertexY(fredkasinosurf,i)+0.7))*0.5
				VertexColor fredkasinosurf,i,HSVr(werbungGrad,s,v),HSVg(werbungGrad,s,v),HSVb(werbungGrad,s,v)
			Next
			
			
			sc#=Sin(fredkopfgrad)*0.05+0.45
			ScaleEntity fredkopf,sc,sc,1
			
			;FredkopfFarbe?
			
			For i=0 To CountVertices(fredkopfsurf)-1
				s#=0.5-Int((VertexY(fredkopfsurf,i)+0.6)/1.2)*0.5
				v#=1;Int(VertexY(fredkopfsurf,i)/0.6)*0.5+0.5
				
				
				VertexColor fredkopfsurf,i,HSVr(werbungGrad,s,v),HSVg(werbungGrad,s,v),HSVb(werbungGrad,s,v)
			Next
			
			;FredkopfFarbe?
			
			;DebugLog werbungGrad+"->"+Hex(HSVhex(werbungGrad,1,1))
			
			For i=0 To 1
				VertexColor HGsurf,werbungHGvO[i],HSVr(werbungGrad,1,0.75),HSVg(werbungGrad,1,0.75),HSVb(werbungGrad,1,0.75)
				VertexColor txtsurf,werbungTextvO[i],HSVr(werbungGrad,0.5,1),HSVg(werbungGrad,0.5,1),HSVb(werbungGrad,0.5,1)
				
				
				VertexColor HGsurf,werbungHGvU[i],HSVr(werbungGrad,1,0.25),HSVg(werbungGrad,1,0.25),HSVb(werbungGrad,1,0.25)
				VertexColor txtsurf,werbungTextvU[i],HSVr(werbungGrad,0.75,0.75),HSVg(werbungGrad,0.75,0.75),HSVb(werbungGrad,0.75,0.75)
				
			Next
			
			;DebugLog HSVr(werbungGrad,1,1)+";"+HSVg(werbungGrad,1,1)+";"+HSVb(werbungGrad,1,1)
			
			RotateTexture HGstrahlen0,HGstrahlen0Grad
				HGstrahlen0Grad=(HGstrahlen0Grad Mod 360)+.1
			
			SetBuffer TextureBuffer(txtcan)
				Color 0,0,0
				Rect 0,0,512,64
				
				SetFont txtfont
				
				Color HSVr(werbungGrad,0.25,0.75),HSVg(werbungGrad,0.25,0.75),HSVb(werbungGrad,0.25,0.75)
				
				Local txt$[1]

				
				If spielTxtGewinn>0
					If spielTxtGewinnZeit=<MilliSecs()
						spielTxtGewinn=0
					Else
						txt[0]=" !+ "+TxtMin(spielRolleGewinn[spielTxtGewinn],2)+" Ticket/s ! "
						txt[1]=" !Ticket/s:"+TxtMin(spielRolleTickets,4)+" ! "
					EndIf
					
				ElseIf spielTxtGewinn=0
					;Ab hier folgende Mglichkeiten: Jede 1,75s fr 0,25s einblenden wie viele Tickets
					;Oder der ausgewhlte Text, der allerdings vorher gendert werden muss, wenn ntig
					

					
					If (MilliSecs() Mod 10000)/2000=0
						
						txt[0]=" *   Ticket/s   * "
						txt[1]=" *    ~"+TxtMin(spielRolleTickets,4)+"~    * "
						
					Else
						
						txt[0]=spielTxtArray[spielTxt+0]
						txt[1]=spielTxtArray[spielTxt+1]
						
					EndIf
					
					If spielTxtZeit=<MilliSecs()
					
						txtZufall=0
						Repeat
							anders=1
							txtZufall=Rand(0,spielTxtMax)*2
							
							For i=0 To 9
								anders=anders And txtZufall<>spielTxtLetzte[i] 
							Next
						Until anders
						
						For i=1 To 9
							spielTxtLetzte[i]=spielTxtLetzte[i-1]
						Next
						spielTxtLetzte[0]=txtZufall
						
						
						spielTxt=txtZufall
						spielTxtZeit=MilliSecs()-(MilliSecs() Mod 10000)+10000;Whrend des einblendens also ndern...klu...k!
					EndIf
					
				EndIf
				
				For ii=0 To 1
					For i=0 To Len(txt[ii])-1
						;Text i*16,ii*24-4,Mid(txt[ii],i+1,1)
						;DebugLog Asc(Mid(txt[ii],i+1,1))
						DrawImage fontsys,i*16,ii*24-6,Asc(Mid(txt[ii],i+1,1))
					Next
				Next
				
			SetBuffer BackBuffer()
			
		End Function
	
	;Hintergrund
	
	;Ticket;
	
	Global ticket=LoadAnimMesh("ticket.b3d"),tickettex[8]
			PositionEntity ticket,0.75,1,-1.2
	
	
	For i=0 To 8
		tickettex[i]=LoadTexture("ticket"+i+".png",1+2)
	Next
	
	EntityTexture ticket,tickettex[0]
	
	;Ticket;
	
	;Textfeld! :D;
	
	Global werbungText=CreateMesh(),txtsurf=CreateSurface(werbungText),werbungTextvO[1],werbungTextvU[1]
		EntityFX werbungText,1+2
	
		werbungTextvO[0]=AddVertex(txtsurf,-0.9,0.3,0,0  ,0)
		werbungTextvO[1]=AddVertex(txtsurf, 0.9,0.3,0,0.5625,0)
		werbungTextvU[0]=AddVertex(txtsurf, 0.9,0  ,0,0.5625,0.75)
		werbungTextvU[1]=AddVertex(txtsurf,-0.9,0  ,0,0  ,0.75)
		
		AddTriangle(txtsurf,werbungTextvO[0],werbungTextvO[1],werbungTextvU[0])
		AddTriangle(txtsurf,werbungTextvO[0],werbungTextvU[0],werbungTextvU[1])
		
		PositionEntity werbungText,0,1.6,-0.7
		
	Global txtText=CreateMesh(werbungText),txttextsurf=CreateSurface(txtText)
		EntityFX    txtText,1+2
		EntityBlend txtText,3
	
		v0=AddVertex(txtTextsurf,-0.9,0.3,0	,0  ,0)
		v1=AddVertex(txtTextsurf, 0.9,0.3,0	,0.5625,0)
		v2=AddVertex(txtTextsurf, 0.9,0  ,0	,0.5625,0.75)
		v3=AddVertex(txtTextsurf,-0.9,0  ,0	,0  ,0.75)
		
		AddTriangle(txtTextsurf,v0,v1,v2)
		AddTriangle(txtTextsurf,v0,v2,v3)
		
		PositionEntity txtText,0,0,-0.01
	
	
	Global txtfont=LoadFont("fixedsys",28),fontsys=LoadAnimImage("fontsys.png",16,32,0,256)
	Global txtcan=CreateTexture(512,64),txtpix=LoadTexture("textfeldpixel.png",1),werhg=LoadTexture("textfeld.png",1)
			EntityTexture werbungText,werhg
			
			EntityTexture txtText,txtcan ,0,0
			EntityTexture txtText,txtpix ,0,2
							
	;Textfeld! :D;
	
;"WERBUNG"

;ROLLE

Global spielRolleGewinn[8],spielTxtGewinn,spielTxtGewinnZeit
	spielRolleGewinn[0]=0
	spielRolleGewinn[1]=1
	spielRolleGewinn[2]=3
	spielRolleGewinn[3]=5
	spielRolleGewinn[4]=7
	spielRolleGewinn[5]=10
	spielRolleGewinn[6]=15
	spielRolleGewinn[7]=20
	spielRolleGewinn[8]=30

Global spielTxtArray$[99],spielTxtMax=25-1,spielTxt,spielTxtZeit,spielTxtLetzte[9]
	spielTxtArray[00]=" *  Fredkasino  * "
	spielTxtArray[01]=" *  Mausklick!  * "
	spielTxtArray[02]=" -Coleus  Canina- "
	spielTxtArray[03]="aka. "+Chr(34)+"VerpissDich"+Chr(34)
	spielTxtArray[04]=" Schon  Left4Fred "
	spielTxtArray[05]="    probiert?     "
	spielTxtArray[06]="  ~Banalitten?~  "
	spielTxtArray[07]="  !Esst Bananen!  "
	spielTxtArray[08]=" Bezweilfe selber "
	spielTxtArray[09]="  meinen Sinn :(  "
	spielTxtArray[10]=" Bananen sind gut,"
	spielTxtArray[11]="   Hhner auch!   "
	spielTxtArray[12]="   ..Kuchen..     "
	spielTxtArray[13]="..eine..   ..Lg.."
	spielTxtArray[14]="####??FALSCH??####"
	spielTxtArray[15]="###TEXT#FEHLEND###"
	spielTxtArray[16]=" BCC# Thema Idee? "
	spielTxtArray[17]=" TagNachtwechsel! "
	spielTxtArray[18]="Rettet die Wlder?"
	spielTxtArray[19]=" Esst mehr Bieber!"
	
	spielTxtArray[20]=" Durch 0 teilen ? "
	spielTxtArray[21]="  Tu. Es. Nicht.  "
	spielTxtArray[22]="*Freds Kochstudio*"
	spielTxtArray[23]="  Bananenkuchen!  "
	spielTxtArray[24]="*Freds Kochstudio*"
	spielTxtArray[25]="panierte Banane!  "
	spielTxtArray[26]="*Freds Kochstudio*"
	spielTxtArray[27]=" Was-auch-immer!  "
	spielTxtArray[28]="Mist. Ist das Ding"
	spielTxtArray[29]=" an? 1 2 3 Test ? "	
	
	spielTxtArray[30]="    Blablabla.    "
	spielTxtArray[31]=" Spielsucht. Bla. "
	spielTxtArray[32]="  Dumme Sprche?  "
	spielTxtArray[33]="  Nur her damit!  "
	spielTxtArray[34]=" Anno? Quersumme? "
	spielTxtArray[35]="  Immer 9! Echt!  "
	spielTxtArray[36]=" ||    //\\  ||   "
	spielTxtArray[37]=" ||__  \\//  ||__ "
	spielTxtArray[38]=" Zweizeiler Nr.20 "
	spielTxtArray[39]=" ...keine Ahnung! "
	
	spielTxtArray[40]="Werbung anders als"
	spielTxtArray[41]="Realitt? Haha! :("
	spielTxtArray[42]="*Freds Kochstudio*"
	spielTxtArray[43]="    Bananeneis !  "
	spielTxtArray[44]="*Freds Kochstudio*"
	spielTxtArray[45]="   Bananenchips!  "
	spielTxtArray[46]="*Freds Kochstudio*"
	spielTxtArray[47]="   Schokobanane!  "
	spielTxtArray[48]="*Freds Kochstudio*"
	spielTxtArray[49]="  <Platzhalter>!  "
					  ;012345789012345678;
	
	spielTxtZeit=MilliSecs()-(MilliSecs() Mod 5000)+5000
	
Global spielRolleTickets=10,spielRollePhase,spielRolleZeit
	
	If FileType("data.ini")=1
		datei=ReadFile("data.ini")
			spielRolleTickets=ReadInt(datei)
		CloseFile datei
	EndIf

Type rolle
	;Allgemein
		Field rolle;Mesh
			Field rolleblur;Mesh
				Field rolleblurzeit
			Field soundstart,soundstop
	
	;"Physik"
		Field rolleV#;Grad in Sekunden
		Field rolleA#;Grad Beschleunigung in S
		Field rolleVer;Gradzhler
	
	;"KI"
		Field rollePhase;Welcher Schritt der KI bearbeitet wird
			Field rolleZahl;Angestrebter Rotationsgrad ( Zahl * 45 )
			Field rolleZahlen[7];
			Field rolleWarte;Verzgerung (damit nicht alles gleichzeitig rollt)
		Field rolleZeit,rolleZeitSeit;Lnge dieser Phase
End Type


Function NeuRolle.rolle(zahlen$,x#=0,y#=0,z#=0,warte=0)
	;Neue Rolle erstellen
	
	Local ro.rolle=New rolle
		
		For i=0 To 7
			
			;Zahlen werden fr die Rolle wie folgt genutzt:
			;"12345678", "87654321" usw.
			
			ro\rolleZahlen[i]=Int(Mid(zahlen,i+1,1))
			
			rolle=LoadMesh("rolleteil.b3d")
				RotateMesh rolle,45-i*45,0,0
				;ScaleMesh rolle,0.8,0.8,0.8
				
				surf=GetSurface(rolle,1)
				
				For ii=0 To CountVertices(surf)-1
					
					VertexTexCoords surf,ii,VertexU(surf,ii),VertexV(surf,ii)+0.125*(ro\rolleZahlen[i]-1)
					
				Next
			
			If ro\rolle=0
				
				ro\rolle=rolle
				
			Else
			
				AddMesh rolle,ro\rolle
				
				FreeEntity rolle
					
			EndIf
				
		Next
		
		For i=0 To 7
			
			;Zahlen werden fr die Rolle wie folgt genutzt:
			;"12345678", "87654321" usw.
			
			ro\rolleZahlen[i]=Int(Mid(zahlen,i+1,1))
			
			rolle=LoadMesh("rolleteilblur.b3d")
				RotateMesh rolle,45-i*45,0,0
				;ScaleMesh rolle,0.8,0.8,0.8
				
				surf=GetSurface(rolle,1)
				
				For ii=0 To CountVertices(surf)-1
					
					VertexTexCoords surf,ii,VertexU(surf,ii),VertexV(surf,ii)+0.125*(ro\rolleZahlen[i]-1)
					
				Next
			
			If ro\rolleblur=0
				
				ro\rolleblur=rolle
				
			Else
			
				AddMesh rolle,ro\rolleblur
				
				FreeEntity rolle
					
			EndIf
				
		Next
			
				EntityParent ro\rolleblur,ro\rolle,0
				EntityBlend  ro\rolleblur,3
				EntityFX	 ro\rolleblur,1
		
			PositionEntity ro\rolle,x,y,z
			
			ro\soundstart=Load3DSound("start.wav")
			ro\soundstop =Load3DSound("stopp.wav")
		
		ro\rolleWarte=warte
	
	Return ro
End Function

Function RollePosition(ro.rolle,zahl)
	;DebugLog "Suche "+zahl
	For i=0 To 7
		
		If zahl=ro\rolleZahlen[i] Then Return i;:DebugLog "Gebe Pos:"+i+" als gesuchtes "+ro\rolleZahlen[i]
		
	Next
End Function

Function RolleZahl(ro.rolle)
	
	Return ro\rolleZahlen[ro\rolleZahl]
	
End Function

;Global spielRolleTickets=10,spielRollePhase,spielRolleZeit
;spielRollePhase:
	;0 - nada, nichts -> 1
	;1 - rollen! -> 2
	;2 - fertig gerollt, Geld! -> 0

Function updRolle()
	If spielRolleZeit=<MilliSecs()
		Select spielRollePhase
			Case 0
				If MouseHit(1)
					FlushMouse
					spielRollePhase=1
					spielRolleZeit=MilliSecs()+3500
					
					Animate banditarm,3,0.2
					
					PlaySound banditwette
					
					;EINSATZ;
					spielRolleTickets=spielRolleTickets-1
					
				EndIf
			Case 1
				spielRollePhase=0
				
				FlushMouse
				
					EntityTexture ticket,tickettex[gewinnRolle()]
				
				If gewinnRolle()>0
					
					;SIEG;
					
					spielRolleTickets=spielRolleTickets+spielRolleGewinn[gewinnRolle()]
					
					PlaySound banditgewinn
					
					
					Animate ticket,3,0.1
					
					spielTxtGewinn    =GewinnRolle()
					spielTxtGewinnZeit=MilliSecs()+5000
					
					For ro.rolle=Each rolle
						
						ro\rolleblurzeit=MilliSecs()+2000
						
					Next
					
				EndIf
					
					datei=WriteFile("data.ini")
						WriteInt datei,spielRolleTickets
					CloseFile datei
					
		End Select
	EndIf
	
	zufall=0
	For ro.rolle=Each rolle
		
		If ro\rolleblurzeit>=MilliSecs()
			
			grad=Sin((ro\rolleblurzeit-MilliSecs())*1.8)*255
			
			
			
			EntityColor ro\rolleblur,grad,grad,grad
			
		Else
			
			EntityColor ro\rolleblur,0,0,0
			
		EndIf
		
		If ro\rolleZeit=<MilliSecs()
			ro\rolleZeit=MilliSecs()
				
				Select ro\rollePhase
					Case 0
						If spielRollePhase=1
							ro\rollePhase=1
							ro\rolleZeit=ro\rolleZeit+500+ro\rolleWarte
							
							ro\rolleZeitSeit=MilliSecs()
							
							ro\rolleA=360*4
							
							
							ro\rolleZahl=0
							zufall=1
							
							;EmitSound ro\soundstart,ro\rolle
						EndIf
					Case 1
						ro\rollePhase=2
						ro\rolleZeit=ro\rolleZeit+1000
						
						ro\rolleA=0
						ro\rolleV=360*2
						
						
						;ro\rolleGrad=180+ro\rolleZahl*45	
					Case 2
						ro\rollePhase=3
						ro\rolleZeit=ro\rolleZeit+1000
						
						ro\rolleZeitSeit=MilliSecs()
						ro\rolleVer=ro\rolleZahl*45
						
						ro\rolleA=-360*2
					Case 3
						ro\rollePhase=0
						ro\rolleZeit=ro\rolleZeit+1000-ro\rolleWarte
						
						ro\rolleA=0
						ro\rolleV=0
						
						EmitSound(ro\soundstop,ro\rolle)
						
						;DebugLog Handle(ro)+">"+rolleZahl(ro)
						
						;If Abs(ro\rolleGrad-ro\rolleZahl*45)>=25 Then RotateEntity ro\rolle,ro\rolleZahl*45,0,0
						
						;DebugLog Int(ro\rolleGrad)/45+"<-"+ro\rolleGrad
						;DebugLog ">"+ro\rolleZahlen[(Int(ro\rolleGrad+360+22.5)Mod 360)/45];+"}"+ro\rolleGrad+":"+Int(ro\rolleGrad)
			End Select
		EndIf
		
		;If ro\rollePhase<3
			rolleT#=(MilliSecs()-ro\rolleZeitSeit)*0.001
			
			
			;If Handle(ro)=1 Then DebugLog ro\rollePhase+"T: "+rolleT+"A: "+ro\rolleA+"("+(0.5*ro\rolleA*rolleT*rolleT)+") V: "+ro\rolleV+" = "+(0.5*ro\rolleA*rolleT*rolleT+ro\rolleV*rolleT)
			
			RotateEntity ro\rolle,0.5*ro\rolleA*rolleT*rolleT+ro\rolleV*rolleT+ro\rolleVer,0,0
		;EndIf
		
		;ro\rolleV=ro\rolleV+ro\rolleA*zeitFloat
		;TurnEntity ro\rolle,ro\rolleV*zeitFloat,0,0
		;ro\rolleGrad=(ro\rolleGrad+ro\rolleV*zeitFloat)Mod 360
		
	Next
	
	If zufall=1
		;"Zufllig" machen
		
		Local roA.rolle[2],i=0
		
		For ro.rolle=Each rolle
			roA[i]=ro
			
			If roA[i]\rolleZahl=0
				
				roA[i]\rolleZahl=Rand(0,7)
			
				i=i+1
			
			Else
				zufall=0
			EndIf
		Next
		;DebugLog zufall
		If zufall=1
			If Rand(1,1)=1;(Not (roA[0]\rolleZahlen[roA[0]\rolleZahl]=roA[1]\rolleZahlen[roA[1]\rolleZahl] And roA[1]\rolleZahlen[roA[1]\rolleZahl]=roA[2]\rolleZahlen[roA[2]\rolleZahl])) And Rand(0,1)=1
				;DebugLog "Glck!"
				If roA[0]\rolleZahlen[roA[0]\rolleZahl]=roA[1]\rolleZahlen[roA[1]\rolleZahl]
					;DebugLog "ndere 2"
					roA[2]\rolleZahl=RollePosition(roA[2],roA[0]\rolleZahlen[roA[0]\rolleZahl])
					;DebugLog "Glck!!!"
				EndIf
				
				If roA[1]\rolleZahlen[roA[1]\rolleZahl]=roA[2]\rolleZahlen[roA[2]\rolleZahl]
					;DebugLog "ndere 0"
					roA[0]\rolleZahl=RollePosition(roA[0],roA[1]\rolleZahlen[roA[1]\rolleZahl])
					;DebugLog "Glck!!!"
				EndIf
				
				If roA[0]\rolleZahlen[roA[0]\rolleZahl]=roA[2]\rolleZahlen[roA[2]\rolleZahl]
					;	DebugLog "ndere 1"
					roA[1]\rolleZahl=RollePosition(roA[1],roA[0]\rolleZahlen[roA[0]\rolleZahl])
					;DebugLog "Glck!!!"
				EndIf
			EndIf
			
			If roA[0]\rolleZahlen[roA[0]\rolleZahl]=roA[1]\rolleZahlen[roA[1]\rolleZahl] And roA[1]\rolleZahlen[roA[1]\rolleZahl]=roA[2]\rolleZahlen[roA[2]\rolleZahl] And Rand(0,7-roA[0]\rolleZahlen[roA[0]\rolleZahl])=0
				
				rolleZ=Rand(0,2)
				roA[rolleZ]\rolleZahl=(RollePosition(roA[rolleZ],roA[rolleZ]\rolleZahlen[roA[rolleZ]\rolleZahl])+1-2*Rand(0,1)+7)Mod 7
				
				;DebugLog "Bmm!"
				
			EndIf
			
		EndIf
		
		;DebugLog roA[0]\rolleZahl+"("+roA[0]\rolleZahlen[roA[0]\rolleZahl]+")/"+roA[1]\rolleZahl+"("+roA[1]\rolleZahlen[roA[1]\rolleZahl]+")/"+roA[2]\rolleZahl+"("+roA[2]\rolleZahlen[roA[2]\rolleZahl]+")/"
		
	EndIf
End Function

Function gewinnRolle()
	Local roA.rolle[2],i=0
	
	For ro.rolle=Each rolle
		roA[i]=ro
		
		i=i+1
	Next
	
	If RolleZahl(roA[0])=RolleZahl(roA[1]) And RolleZahl(roA[1])=RolleZahl(roA[2])
		;DebugLog RolleZahl(roA[0])
		Return RolleZahl(roA[0])
	EndIf	
End Function


;ROLLE;

;	;ROLLE;
;	;Global rolle=LoadMesh("rolle.b3d")
;	;	RotateMesh rolle,-90+22.5,0,0
;	;	PositionEntity rolle,-0.5,2.5,0
;	;	
;	;	Global rolleV#,rolleA#,rolleGrad#,rollePhase,rolleZeit,rolleZahl
;	;ROLLE;


;GLOBAL;

Global spielRollen.rolle[2]
	spielRollen[0]=NeuRolle("12345678",-0.7	,0.925,-0.4	,000)
	spielRollen[1]=NeuRolle("81726354",-0.2	,0.925,-0.4	,250)
	spielRollen[2]=NeuRolle("87654321", 0.3	,0.925,-0.4	,500)

Global zeitAlt=MilliSecs(),zeit,zeitFloat#
Global fps=CreateTimer(60)



Repeat
;ZEIT

zeit=MilliSecs()-zeitAlt
zeitFloat=zeit/1000.0
zeitAlt=MilliSecs()


	updRolle
	
	PositionTexture leuchtlayer,0,(MilliSecs() Mod 800)/100*-0.125
	
	WerbungUpdHG
	
UpdateWorld
RenderWorld

;Text 0,0,(MilliSecs() Mod 1000)/250*0.25
;Text 0,0,spielRolleTickets

Flip 0
WaitTimer fps
Until KeyHit(1)
End

Function HSVhex(h#,s#,v#);Selbstgemacht! ;o
	Local rf#,gf#,bf#,r,g,b,hexrgb
	
	Local hh#=h/60
	Local c#=v*s
	Local x#=c*(1-Abs((hh Mod 2) -1))
	
	If 0=<hh And hh<1
		rf=c
		gf=x
		bf=0
	ElseIf 1=<hh And hh<2
		rf=x
		gf=c
		bf=0
	ElseIf 2=<hh And hh<3
		rf=0
		gf=c
		bf=x
	ElseIf 3=<hh And hh<4
		rf=0
		gf=x
		bf=c
	ElseIf 4=<hh And hh<5
		rf=x
		gf=0
		bf=c
	ElseIf 5=<hh And hh<6
		rf=c
		gf=0
		bf=x
	EndIf
	
	Local m#=v-c
		
	r=(rf+m)*255
	g=(gf+m)*255
	b=(bf+m)*255
	
	hexrgb=r*$10000+g*$100+b
	
	;DebugLog hexrgb+"|"+h+"|"+s+"|"+v
	;DebugLog r+";"+g+";"+b
	;DebugLog Hex(hexrgb)
	
	Return hexrgb
End Function

Function HSVr(h#,s#,v#)
	Return (HSVhex(h,s,v) And $FF0000)/$10000
End Function

Function HSVg(h#,s#,v#)
	Return (HSVhex(h,s,v) And $FF00)/$100
End Function

Function HSVb(h#,s#,v#)
	Return (HSVhex(h,s,v) And $FF)
End Function

Function TxtMin$(var$,length)
	
	If Len(var)<length
		var=String(" ",length-Len(var))+var
	EndIf
	
	Return var
End Function

;GLOBAL;