Graphics 800,600,0,2
SeedRnd MilliSecs()


AppTitle "Le Casino"



Const GAMESTATE_MENU = 0
Const GAMESTATE_GAME = 1
Const GAMESTATE_GAMEOVER = 2


Global timer = CreateTimer(60)


Global mx
Global my
Global md1
Global mh1
Global mh2
Global mh3


Global ende


AutoMidHandle 1


Global imgCards = LoadAnimImage("cards.png",71,96,0,52)
Global imgJokercard = LoadImage("joker.png")
Global imgBackside = LoadImage("backside.png")


Global imgSuits = LoadAnimImage("suits.png",15,15,0,4)
MaskImage imgSuits,255,0,255


Global hugefont = LoadFont("arial",94,1)
Global bigfont = LoadFont("arial",64,1)
Global mediumfont = LoadFont("arial",32)
Global smallfont = LoadFont("Fixedsys",10)


Const clubs = 0
Const spades = 1
Const diamonds = 2
Const hearts = 3

Const red = 0
Const black = 1


Dim availablecards(12,3)
Global availablecolors[1]
Global availablesuits[3]
Global availablenumbers[12]
Global availablecardstotal


Global texts$[12]
texts[0] = "2"
texts[1] = "3"
texts[2] = "4"
texts[3] = "5"
texts[4] = "6"
texts[5] = "7"
texts[6] = "8"
texts[7] = "9"
texts[8] = "10"
texts[9] = "J"
texts[10] = "Q"
texts[11] = "K"
texts[12] = "A"


Global einsatz[71]


Global money = 5000


Global gewinn


Global karte_aufgedeckt
Global karte_suit
Global karte_number


Global Gamestate


ClsColor 0,128,0


Repeat
	
	mouse()
	
	Select Gamestate
		
		Case GAMESTATE_MENU
			menu()
			
		Case GAMESTATE_GAME
			game()
			
		Case GAMESTATE_GAMEOVER
			gameover()
			
	End Select
	
	WaitTimer timer
	Flip 0
	Cls
	
Until ende = True

End


Function mouse()
	
	mx = MouseX()
	my = MouseY()
	md1 = MouseDown(1)
	mh1 = MouseHit(1)
	mh2 = MouseHit(2)
	mh3 = MouseHit(3)
	
End Function


Function menu()
	
	SetFont hugefont
	Color 255,255,255
	Text 400, 50, "Le Casino", 1, 1
	
	If mx >= 280 And my >= 270 And mx <= 520 And my <= 320 Then
		msel = 1
	End If
		
	If mx >= 280 And my >= 370 And mx <= 520 And my <= 420 Then
		msel = 2
	End If
	
	SetFont bigfont
	If msel = 1 Then Color 200,0,0 : Else Color 255,255,255
	Text 400, 300, "Zocken", 1, 1
	If msel = 2 Then Color 200,0,0 : Else Color 255,255,255
	Text 400, 400, "Beenden", 1, 1
	
	If mh1 Then
		If msel = 1 Then initgame()
		If msel = 2 Then End
	End If
	
	If KeyHit(1) Then ende = True
	
End Function


Function initgame()
	
	gamestate = GAMESTATE_GAME
	
	karte_aufgedeckt = 0
	
	resetcards()
	
End Function

Function resetcards()
	
	For x = 0 To 12
		For y = 0 To 3
			availablecards(x,y) = 1
		Next
	Next
	
	For x = 0 To 3
		availablesuits[x] = 13
	Next
	
	For x = 0 To 1
		availablecolors[x] = 26
	Next
	
	For x = 0 To 12
		availablenumbers[x] = 4
	Next
	
	availablecardstotal = 52
	
End Function


Function game()
	
	If karte_aufgedeckt = 0 Then
		
		DrawImage imgBackside, 400, 80
		SetFont mediumfont
		
		Color 255,255,255
		Text 400, 160, "Was setzen Sie?",1,1
		Text 400, 550, "Taste drcken zum Besttigen",1,1
		
		If money => 0 Then
			
			If mh1 Or mh2 Or mh3 Then
				
				If mx>100 And mx<620 And my>250 And my<410 Then
					number = (mx-100) / 40
					suit = (my-250) / 40
					money = money + (einsatz[suit*13+number]>0)*100*mh2
					einsatz[suit*13+number] = einsatz[suit*13+number] + 100*mh1*(money>=100) + 500*mh3*(money>=500) - (einsatz[suit*13+number]>0)*mh2*100
					money = money - 100*mh1*(money>=100) - 500*mh3*(money>=500) 
				End If
			
				If mx>100 And mx<620 And my>410 And my<450 Then
					number = (mx-100) / 40
					money = money + (einsatz[57+number]>0)*100*mh2
					einsatz[57+number] = einsatz[57+number] + 100*mh1*(money>=100) + 500*mh3*(money>=500) - (einsatz[57+number]>0)*100*mh2
					money = money - 100*mh1*(money>=100) - 500*mh3*(money>=500)
				End If
			
				If mx>620 And mx<660 And my>250 And my<410 Then
					suit = (my-250) / 40
					money = money + (einsatz[53+suit]>0)*100*mh2
					einsatz[53+suit] = einsatz[53+suit] + 100*mh1*(money>=100) + 500*mh3*(money>=500) - (einsatz[53+suit]>0)*100*mh2
					money = money - 100*mh1*(money>=100) - 500*mh3*(money>=500)
				End If
				
				If mx>620 And mx<660 And my>410 And my<450 Then
					money = money + (einsatz[52]>0)*100*mh2
					einsatz[52] = einsatz[52] + 100*mh1*(money>=100) + 500*mh3*(money>=500) - (einsatz[52]>0)*100*mh2
					money = money - 100*mh1*(money>=100) - 500*mh3*(money>=500)
				End If
				
				If mx>660 And mx<700 And my>250 And my<410 Then
					farbe = (my-250)/80
					money = money + (einsatz[70+farbe]>0)*100*mh2
					einsatz[70+farbe] = einsatz[70+farbe] + 100*mh1*(money>=100) + 500*mh3*(money>=500) - (einsatz[70+farbe]>0)*100*mh2
					money = money - 100*mh1*(money>=100) - 500*mh3*(money>=500)
				End If
				
			End If
		
		End If
		
		If GetKey()<>0 Then
			
			karte_aufgedeckt = 1
			Repeat
				kartenr = Rand(0,56)
				karte_suit = kartenr / 13
				If karte_suit < 4 Then karte_number = kartenr Mod 13
				If karte_suit = 4 Then
					ok = 1 : Exit
				Else
					If availablecards(karte_number,karte_suit) = 1 Then ok = 1 : Exit
				End If
			Until ok=1
			
			For i = 0 To 71
				If i<52
					If einsatz[i] > 0 Then
						If karte_suit = i / 13 And karte_number = i Mod 13 Then
							gewinn = gewinn + einsatz[i] * availablecardstotal
						End If
					End If
					einsatz[i] = 0
				End If
				If i=52
					If einsatz[i] > 0 Then
						If karte_suit = 4 Then
							gewinn = gewinn + einsatz[i] * availablecardstotal / 6
						End If
					End If
					einsatz[i] = 0
				End If
				If i>52 And i<57
					If einsatz[i] > 0 Then
						If karte_suit = i-53 Then
							gewinn = gewinn + einsatz[i] * availablecardstotal / availablesuits[karte_suit]
						End If
					End If
					einsatz[i] = 0
				End If
				If i>56 And i<70
					If einsatz[i] > 0 Then
						If karte_number = i-57 Then
							gewinn = gewinn + einsatz[i] * availablecardstotal / availablenumbers[karte_number]
						End If
					End If
					einsatz[i] = 0
				End If
				If i>69
					If einsatz[i] > 0 Then
						If karte_suit/2 = i-70 Then
							gewinn = gewinn + einsatz[i] * availablecardstotal / availablecolors[karte_suit/2]
						End If
					End If
					einsatz[i] = 0
				End If
			Next
			
			money = money + gewinn
			
			If money < 100 Then gamestate = GAMESTATE_GAMEOVER
			
			If karte_suit < 4 Then
				availablecards(karte_number,karte_suit) = 0
				availablecolors[karte_suit/2] = availablecolors[karte_suit/2] - 1
				availablesuits[karte_suit] = availablesuits[karte_suit] - 1
				availablenumbers[karte_number] = availablenumbers[karte_number] - 1
				availablecardstotal = availablecardstotal - 1
			End If
			
		End If
		
	Else
		
		If karte_suit = 4 Then
			DrawImage imgJokercard,400,80
		Else
			DrawImage imgCards,400,80,karte_suit*13+karte_number
		End If
		
		Color 255,255,255
		Text 400, 160, "Sie haben "+gewinn+"$ gewonnen",1,1
		Text 400, 550, "Taste drcken zum Weiterzocken",1,1
		
		If GetKey()<>0 Then karte_aufgedeckt = 0 : gewinn = 0 : If availablecardstotal = 30 Then resetcards()
		
	End If
	
	drawgrid()
	
	If KeyHit(1) Then gamestate = GAMESTATE_MENU
	
End Function


Function drawgrid()
	
	Color 255,255,255
	
	For i = 0 To 14
		
		Line 100+i*40,250,100+i*40,450
		
	Next
	
	For i = 0 To 5
		
		Line 100,250+i*40,660,250+i*40
		
	Next
	
	Line 660,250,700,250
	Line 660,330,700,330
	Line 600,410,700,410
	Line 700,250,700,410
	
	Color 10,10,10
	Rect 661,251,39,79
	
	Color 200,0,0
	Rect 661,331,39,79
	
	SetFont smallfont
	
	For x = 0 To 13
		For y = 0 To 4
			If x <= 12 And y <= 3 Then
				If availablecards(x,y) = 1 Then
					DrawImage imgSuits,115+x*40,265+y*40,y
					If y = 0 Or y = 1 Then Color 10,10,10 : Else Color 200,0,0
					Text 130+x*40,265+y*40,texts[x],1,1
				End If
			ElseIf x = 13 And y <= 3 Then
				DrawImage imgSuits,120+x*40,265+y*40,y
			ElseIf x <= 12 And y = 4
				Color 255,255,255
				Text 120+x*40,260+y*40,texts[x],1,1
			ElseIf x = 13 And y = 4
				Text 120+x*40,260+y*40,"Joker",1,1
			End If
		Next
	Next
	
	Color 160,160,160
	For i = 0 To 71
		If i <= 51 And availablecards(i Mod 13,i / 13) = 1 Then
			Text 120+(i Mod 13)*40,280+(i / 13)*40,einsatz[i]+"$",1,1
		End If
		
		If i>=57 And i<=69 And availablenumbers[i-57] > 0 Then
			Text 120+(i-57)*40,440,einsatz[i]+"$",1,1
		End If
		
		If i>=53 And i<=56 And availablesuits[i-53] > 0 Then
			Text 640,280+(i-53)*40,einsatz[i]+"$",1,1
		End If
		
		If i = 52 Then Text 640,440,einsatz[i]+"$",1,1
		
		If i = 70 Or i = 71 Then
			Text 680,290+(i-70)*80,einsatz[i]+"$",1,1
		End If
	Next
	
	Color 255,255,255
	SetFont mediumfont
	Text 400,500,"Geld: " +money+"$",1,1
	
End Function

Function gameover()
	
	SetFont mediumfont
	Text 400,300,"Sie haben nicht mehr gengend Geld zum weiterspielen",1,1
	SetFont smallfont
	Text 400,350,"Drcken sie eine Taste",1,1
	
	resetcards()
	money = 5000
	
	If GetKey() <> 0 Then gamestate = GAMESTATE_MENU
	
End Function